class PanelsController < ApplicationController
  layout 'test' if Pettanr::TestLayout
  before_filter :authenticate_user!, :only => [:index, :show, :create, :update, :destroy]
  before_filter :authenticate_admin!, :only => [:list, :browse]

  private
  
  def treat_param panel
    panel.author_id = @author.id
  end
  
  public
  
  # GET /panels
  # GET /panels.json
  def index
    @panels = Panel.find(:all, :include => [:comic, :author], :order => 'updated_at', :limit => 20)

    respond_to do |format|
      format.html # index.html.erb
      format.json { render :json => @panels.to_json(
        :include => [:comic, :author]
      ) }
    end
  end

  # GET /panels/1
  # GET /panels/1.json
  def show
    @panel = Panel.find(params[:id], include: [:comic, :panel_pictures => :resource_picture, :balloons => :speaches])# only: [:width, :height])

    respond_to do |format|
      format.html # show.html.erb
       format.json {
        render :json => @panel.to_json(include: {
          :comic => {}, :panel_pictures => {:include => :image}, :fukidashis => {:include => :serifus}
        })
      }
      format.jsonp {
        render :json => "callback(" + @panel.to_json(include: {
          :comic => {}, :panel_pictures => {:include => :image}, :fukidashis => {:include => :serifus}
        }) + ");"
      }
#      format.json { render :json => @frame.to_json(include: {
#        :comic => {:only => :title}, :panel_pictures => {:include => {:image => {:only => [:width]}},:only => [:width, :height, :z, :image_id]}
#      }, only: [:border]) }
    end
  end

  def list
    @panels = Panel.all :order => 'updated_at'

    respond_to do |format|
      format.html { render layout: 'system' }
      format.json { render json: @panels }
    end
  end

  def browse
    @panel = Panel.find(params[:id])

    respond_to do |format|
      format.html { render layout: 'system' }
    end
  end

  # POST /panels
  # POST /panels.json
  def create
    if params[:json]
      jsn = JSON.parse(params[:json])
    end
    @prm = params[:panel] || jsn
    @panel = Panel.new(@prm)
    treat_param @panel
    @comic = Comic.find @panel.comic_id

    respond_to do |format|
      Panel.transaction do
        if @panel.vdt_save
          format.html { redirect_to @panel, notice: 'Panel was successfully created.' }
          format.json { render json: @panel, status: :created, location: @panel }
        else
          format.html { render action: "new" }
          format.json { render json: @panel.errors, status: :unprocessable_entity }
        end
      end
    end
  end

  # PUT /panels/1
  # PUT /panels/1.json
  def update
    @panel = Panel.find(params[:id])
    if @panel.own? @author
      respond_to do |format|
        Panel.transaction do
          if params[:panel][:t] and params[:panel][:t].to_i != @panel.t
            @panel.move_to params[:panel][:t].to_i
          end
          if @panel.update_attributes(params[:panel])
            format.html { redirect_to @panel, notice: 'Panel was successfully updated.' }
            format.json { head :ok }
          else
            format.html { render action: "edit" }
            format.json { render json: @panel.errors, status: :unprocessable_entity }
          end
        end
      end
    else
      format.html { render action: "edit" }
      format.json { render json: @panel.errors, status: :unprocessable_entity }
    end
  end

  # DELETE /panels/1
  # DELETE /panels/1.json
  def destroy
    @panel = Panel.find(params[:id])
    if @panel.own? @author
      respond_to do |format|
        Panel.transaction do
          @panel.destroy_and_shorten
          format.html { redirect_to panels_url }
          format.json { head :ok }
        end
      end
    else
      format.html { render action: "edit" }
      format.json { render json: @panel.errors, status: :unprocessable_entity }
    end
  end
  
  def move
    @panel = Panel.find(params[:id])
    @new_seq = params[:panel][:t].to_i
    respond_to do |format|
      Panel.transaction do
        if @panel.move_to(@new_t)
          format.html { redirect_to @panel, notice: 'Panel was successfully moved.' }
          format.json { head :ok }
        else
          format.html { render action: "show" }
          format.json { render json: @panel.errors, status: :unprocessable_entity }
        end
      end
    end
  end
  
end
